unit MOWMAPit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, MAPOCX, ExtCtrls, StdCtrls, Buttons, ComCtrls, DB, DBTables,
 Mask,Printers,  Math, ColorGrd,DataMod,MapUtil, MapItem,DirDraw;

type
  TMOWMAP = class(TForm)
    ToolPanel: TPanel;
    MapPanel: TPanel;
    OlePmMap1: TOlePmMap;
    PrintButton: TSpeedButton;
    ZinButton: TSpeedButton;
    ClientSetHandButton: TSpeedButton;
    RouteOKButton: TSpeedButton;
    RouteGroup: TRadioGroup;
    MOWImage: TImage;
    ClientGroup: TRadioGroup;
    ClientEdit: TEdit;
    BmpImg1: TImage;
    BmpImg2: TImage;
    HelpButton: TSpeedButton;
    CloseButton: TSpeedButton;
    Info: TStatusBar;
    MapProgressBar: TProgressBar;
    Paintit: TSpeedButton;
    ToolButton: TSpeedButton;
    ClearitButton: TSpeedButton;
    ColorGrid1: TColorGrid;
    ShapesB: TSpeedButton;
    Erased: TSpeedButton;
    Item: TSpeedButton;
    SaveBitMap: TSpeedButton;
    SaveBmpDlg: TSaveDialog;
    SP: TSpeedButton;
    NSP: TSpeedButton;
    API: TSpeedButton;
    DDS: TSpeedButton;
    DD: TSpeedButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrSet: TSpeedButton;
    Image1: TImage;
    MilesEd: TEdit;
    Label1: TLabel;
    MemoryPrint: TSpeedButton;
    procedure InfoDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
              const Rect: TRect);
    procedure CloseBitBtnClick(Sender: TObject);
    procedure ToolClick(Sender: TObject);
    procedure MapPanelResize(Sender: TObject);
    procedure PrintButtonClick(Sender: TObject);
    procedure RouteGroupClick(Sender: TObject);
    procedure RouteOKButtonClick(Sender: TObject);
    procedure ClientGroupClick(Sender: TObject);
    procedure ClientSetHandButtonClick(Sender: TObject);
    procedure ClientEditChange(Sender: TObject);
    procedure ZinButtonClick(Sender: TObject);
    procedure HelpBitBtnClick(Sender: TObject);
    procedure OlePmMap1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OlePmMap1Click(Sender: TObject);
    procedure OlePmMap1Status(Sender: TObject; s: Integer);
    procedure ClearitClick(Sender: TObject);
    procedure SaveBitMapClick(Sender: TObject);
    procedure ItemClick(Sender: TObject);
    procedure OlePmMap1paintAfter(Sender: TObject; dc: Integer);
    procedure SPClick(Sender: TObject);
    procedure NSPClick(Sender: TObject);
    procedure APIClick(Sender: TObject);
    procedure DDClick(Sender: TObject);
    procedure DDSClick(Sender: TObject);
    procedure PrSetClick(Sender: TObject);
    procedure OlePmMap1Direct(Sender: TObject; dc: Integer);
    procedure FormResize(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure MemoryPrintClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
private
    { Private declarations }
  public
    { Public declarations }
  end;

var
   MOWMAP: TMOWMAP;
   Lon,Lat:Double;
   RtS,ClS,MaddName:String;
   RtN,ClN,Which:Integer;
DONOTDO,   MOWSetting:Boolean;

implementation

{$R *.DFM}
{$R Cursor15.Res}
Uses Mowmain;

procedure TMOWMAP.InfoDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
  const Rect: TRect);
begin// Updates the scale bar contained in the status panel
with StatusBar.Canvas do
  OlePmMap1.DrawScaleBar(StatusBar.Canvas.handle,Rect.Left+2,Rect.Top+2);
 end;

procedure TMOWMAP.OlePmMap1Status(Sender: TObject; s: Integer);
begin
MapProgressBar.Position := s;
end;

procedure TMOWMAP.FormShow(Sender: TObject);
 Var Cntr : integer;
begin
WindowState:= WsMaximized;
  Left := 0;
  Top := 0;
  MapPanel.Width:=(ClientWidth-2);
  MapPanel.Height:= (ClientHeight-65);

 With OlePmMap1 do
 Begin
  Top := 0;
  Left := 0;
  Width := MapPanel.Width;
  Height := MapPanel.Height;
  end;
 OlePmMap1.Screen_Aspect := 1;
 Screen.Cursors[15] := LoadCursor(Hinstance,'Cursor15');
{ FindList := TstringList.Create;}

 for Cntr := 0 to 9  do      // Intialize the array
 with ItemRec[Cntr] do
 Begin
     MOWZDB.MapClientTable.Locate('Client',Cntr,[]);
  Id := Cntr;
  Lon :=  MOWZDB.MapClientTableLon.Value;
  Lat :=   MOWZDB.MapClientTableLat.Value;
  Comment := 'Item ' + IntToStr(Cntr +1)+' '
  + MOWZDB.MapClientTableAddName.Value;
 End;
 ItemCntr := 0;

   With MOWMAP.OlePmMap1 do
   Begin
    AutoQuery:= True;
    BackDraw:=True;
    EdgePan:=True;
    Enabled := True;
    Grid:=False;
    Load_Hydro := False;
    Load_Highway := False;
    Load_County := False;
    Load_State := True;
    Load_City := True;
    Load_Air := True;
    Load_Landmark :=False;
    Mainlay:=True;
    Overlay:=True;
    Path_States := 'F:\mow\map';
    Path_Data1 :='F:\mow\map';
    Path_Data2 :='F:\mow\map';
    Path_Data3 := 'F:\mow\map';
    SaveView:=False;
Shade_Cnty:=False;
Shade_Mcd:=False;
Shade_Plc:=False;
Shade_State:=False;
    End;
OlePmMap1.DeleteAllItems;
RouteGroup.ItemIndex:=0;;
ClientGroup.ItemIndex:=0;
RouteGroupClick(Sender);
  Application.OnHint := MOWMAP.ShowHint;
end;
procedure TMOWMAP.ShowHint(Sender: TObject);
begin
{  StatusBar.SimpleText}
  Info.Panels.items[0].Text := Application.Hint;
end;

procedure TMOWMAP.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 {Findlist.free; }
 OlePmMap1.DeleteAllItems;  // Deletes items created by user
{ IniWrite;}
  Application.OnHint := MainForm.ShowHint;
{MainForm.StatusBar.SimpleText := Application.Hint;}
end;

procedure TMOWMAP.CloseBitBtnClick(Sender: TObject);
begin
Close;
end;

procedure TMOWMAP.ToolClick(Sender: TObject);
begin
OlePmMap1.ShowToolBar;
end;

procedure TMOWMAP.MapPanelResize(Sender: TObject);
begin
 OlePmMap1.Width := MapPanel.Width;
 OlePmMap1.Height := MapPanel.Height;
end;
procedure TMOWMAP.FormResize(Sender: TObject);
begin
  MapPanel.Width:=(ClientWidth -2);
  MapPanel.Height:=(ClientHeight -91);

end;


procedure TMOWMAP.PrintButtonClick(Sender: TObject);
begin
OlePmMap1.ExecPrint;
end;

procedure TMOWMAP.RouteGroupClick(Sender: TObject);
var LL,LT,LR,LB:Double; CI:Integer;
begin{Change the Route}
RtN:=RouteGroup.ItemIndex;
inc(RtN);
           Begin
                 MOWZDB.MapViewTable.Locate('Route',RtN,[]);
                 LL:=    MOWZDB.MapViewTableLonLeft.Value;
                 LT:=    MOWZDB.MapViewTableLatTop.Value;
                 LR:=    MOWZDB.MapViewTableLonRight.Value;
                 LB:=    MOWZDB.MapViewTableLatBottom.Value;
                 OlePmMap1.ZoomWindow(LL,LT,LR,LB);
            End;
OlePmMap1.DeleteAllItems;
For CI:= 1 to 10 DO
Begin
   Which:= ((RtN*10) +CI);
   MOWZDB.MapClientTable.Locate('Client',Which,[]);
  {MapClientTableClient: TIntegerField;}
   Lon:=    MOWZDB.MapClientTableLon.Value;
   Lat:=    MOWZDB.MapClientTableLat.Value;
   MaddName:= MOWZDB.MapClientTableAddName.Value;
        OlePmMap1.SetItem(Which,Lon,Lat);
        OlePmMap1.SetItemBitMap(Which,MOWMAP.BmpImg1.Picture.Bitmap.Handle);
        OlePmMap1.SetItemString(Which,MaddName);
End;
ClN:=(ClientGroup.ItemIndex);
inc(ClN);
   Which:= ((RtN*10) +ClN);
   MOWZDB.MapClientTable.Locate('Client',Which,[]);
   MaddName:= MOWZDB.MapClientTableAddName.Value;
  ClientEdit.Text:=MaddName;
str((RtN),RtS);
str(ClN,ClS);
  Info.Panels.items[0].Text := 'Route = ' + RtS + '  Client = '+ClS
  +'  '+  OlePmMap1.Dms(Lon) + ' ' + OlePmMap1.Dms(Lat);
  OlePmMap1.Redraw;
end;

procedure TMOWMAP.RouteOKButtonClick(Sender: TObject);
var HorizMiles,VertMiles:Double;SizeS:String;
begin
{SET the Route , determine which from RouteGroup Index
get the 4 corners and save...}
RtN:=RouteGroup.ItemIndex;
inc(RtN);
ClN:=(ClientGroup.ItemIndex);
 With OlePmMap1 do
 Begin// Thousandths of mi.
  HorizMiles := Distance(LonLeft,LatTop,LonRight,LatTop);
  VertMiles := Distance(LonLeft,LatTop,LonLeft,LatBottom);
  SizeS:='Map Display  = ' +
      FloatToStrF(HorizMiles / 1000,ffFixed,8,2) + ' by ' +
      FloatToStrF(VertMiles / 1000,ffFixed,8,2) + ' Miles';
 Info.Panels.items[0].Text :=SizeS;
 End;
            Begin
                 MOWZDB.MapViewTable.Locate('Route',RtN,[]);
                 MOWZDB.MapViewTable.Edit;
                 MOWZDB.MapViewTableLonLeft.Value:=OlePmMap1.LonLeft;
                 MOWZDB.MapViewTableLatTop.Value:=OlePmMap1.LatTop;
                 MOWZDB.MapViewTableLonRight.Value:=OlePmMap1.LonRight;
                 MOWZDB.MapViewTableLatBottom.Value:=OlePmMap1.LatBottom;
                 MOWZDB.MapViewTableSize.Value:=SizeS;
                 MOWZDB.MapViewTable.Post;
            End;
OlePmMap1.Redraw;
end;

procedure TMOWMAP.ClientGroupClick(Sender: TObject);
begin
{Select which Client ITEM to be using for
ClientEdit
and Location placement using ClientSetHandButtonClick}
RtN:=RouteGroup.ItemIndex;
inc(RtN);
ClN:=(ClientGroup.ItemIndex);
inc(ClN);
Which:= ((RtN*10) +ClN);
MOWZDB.MapClientTable.Locate('Client',Which,[]);
        Lon:=    MOWZDB.MapClientTableLon.Value;
        Lat:=    MOWZDB.MapClientTableLat.Value;
        MaddName:= MOWZDB.MapClientTableAddName.Value;
        ClientEdit.Text:=MaddName;
str((RtN),RtS);
str(ClN,ClS);
  Info.Panels.items[0].Text := 'Route = ' + RtS + '  Client = '+ClS
+'  '+  OlePmMap1.Dms(Lon) + ' ' + OlePmMap1.Dms(Lat);
End;


procedure TMOWMAP.ClientSetHandButtonClick(Sender: TObject);
{ var H1 : Hcursor;}
begin
MOWSetting:=True;
{Change Cursor type}
with OlePmMap1 do
Begin
 mapmode := 1;{Cursor := crCross;}
 Cursor := 15;   // uses oCX defined cursor
{ // Cursor := 15;   // uses oCX defined cursor
 H1 := LoadCursor(Hinstance,'cursor15'); // User cursor in cursor15.Res
 Custom := H1;}
end;
End;

procedure TMOWMAP.OlePmMap1Click(Sender: TObject);
begin  // Store the mouse co-ordinates every time the map is clicked
 With MOWRec{FstrRec} do
 Begin
  LonCtr := OlePmMap1.Xcord;
  LatCtr := OlePmMap1.Ycord;
  Lon:=LonCtr;
  Lat:=LatCtr;
 End;
 If MOWSetting then begin
{Place the Client Item... Client Index number}
RtN:=RouteGroup.ItemIndex;
inc(RtN);
ClN:=(ClientGroup.ItemIndex);
inc(ClN);
Which:= ((RtN*10) +ClN);
        OlePmMap1.SetItem(Which,Lon,Lat);
        OlePmMap1.SetItemBitMap(Which,MOWMAP.BmpImg1.Picture.Bitmap.Handle);
        OlePmMap1.SetItemString(Which,MaddName);
        MOWZDB.MapClientTable.Edit;
        MOWZDB.MapClientTableLon.Value:=Lon;
        MOWZDB.MapClientTableLat.Value:=Lat;
        MOWZDB.MapClientTable.Post;
OlePmMap1.Redraw;
End;
end;

procedure TMOWMAP.ClientEditChange(Sender: TObject);
begin
{Change the text associated with the ITEM currently selected
from/using ClientGroup Index number}
MaddName:=ClientEdit.Text;
MOWZDB.MapClientTable.Edit;
MOWZDB.MapClientTableAddName.Value:=MaddName;
MOWZDB.MapClientTable.Post;
end;

procedure TMOWMAP.ZinButtonClick(Sender: TObject);
begin
{Change from Selecting/Placing Clients to ZOOM/ROAM capability}
begin   // Was zoomIwin Changed to illustrate mapmode property
 OlePmMap1.MapMode := 0;
 MOWSetting:=False;
end;

end;

procedure TMOWMAP.HelpBitBtnClick(Sender: TObject);
begin{Help Form: 500, This is 500...599}
Application.HelpContext(500);
end;

procedure TMOWMAP.OlePmMap1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
{ Dms Converts a double value in decimal degrees into a     }
{ Degree:Minute:Second string.                              }
{ LonLatStr converts 2 double values to a string containing }
{ Degree:Minute:Second  , Degree:Minute:Second              }
{ xcord, ycord returns the Longitude, Latitude in decimal   }
{ degrees of the current cursor position.                   }
 With OlePmMap1 do
  Begin { StatusBarR.SimpleText :=}
   Info.Panels.items[2].Text := Dms(xcord) + ' ' + Dms(ycord);
    {
   If MapMode = 1 then with FstrRec do  // Map user mode selected
   Begin  // Show the distance in miles based on the last click Lon Lat on map.
    Info.Panels.Items[0].Text :=
     FloatToStrF(Distance(LonCtr,LatCtr,xcord,ycord)/ 1000,fffixed,6,2)
     +' Miles';
   End;
   }
  End;
end;

{
procedure TMOWMAP.EnhancedRedraw1Click(Sender: TObject);
begin
 EnhancedRedraw1.Checked := Not EnhancedRedraw1.Checked;
 With OlePmMap1 do
 Begin
  BackDraw := EnhancedRedraw1.Checked;
  Redraw;
 End;
end;
}
procedure TMOWMAP.OlePmMap1paintAfter(Sender: TObject; dc: Integer);
 Var hp : Hpen;
     tmpxLoc,tmpyLoc,{diff,}R,R1,Bearing: Double;
     X1,Y1,X2,Y2  : Integer;
     DrwRect : LLRect;
begin  DONOTDO:=FALSE;
  with MOWMAP.OlePmMap1 do
  Begin                  // Draw the new scale and display magnitude etc.
   Info.refresh;         // See the Info DrawPanel Event - DrawScaleBar
   MilesEd.Text := FloatToStrF(Miles,ffFixed,6,2);
{   MagEd.Text := IntToStr(Magnitude);
   ScaleEd.Text := FloatToStrf(Scale,ffFixed,8,4);}
   tmpxLoc := (LonLeft + LonRight) / 2; // Center on screen
   tmpyLoc := (LatTop + LatBottom) / 2;

   If DONOTDO {DrawOnMap1.Checked} then   // Menu selection
   Begin
   // Shows how to draw on map using WinApi. Draws diagonal line on screen.
   // Lon2Int, Lat2Int converts double to map display co-ordinates

   { Create and select a blue pen }
   hp := CreatePen(0,1,RGB(0,0,$ff));
   hp := SelectObject(Dc,hp);

   { Draw a line }
   MoveToEx(Dc,Lon2Int(LonLeft),Lat2Int(LatBottom),NIL);
   LineTo(Dc,Lon2Int(LonRight),Lat2Int(LatTop));

   { Deselect and delete Pen }
   DeleteObject(SelectObject(Dc,hp));
  End;  // DrawOnMap1.Checked

  If DONOTDO {DrawBubbleOnMap1.Checked }then
   Begin
    { Draw a text bubble on the map with some Ellipse' }
    { using WinAPI calls.  Illustrates the effect of   }
    { screen_aspect property.                           }
    Drawbubble(Dc,tmpXloc,tmpYLoc,'Which Ellipse is 10 miles in diameter?');

     // Draw a Ellipse on the screen with no fill
     SetRop2(dc,R2_NotXorPen);

      { Create and select a blue pen }
    hp := CreatePen(0,1,RGB(0,0,$ff));
    hp := SelectObject(Dc,hp);

{   diff := GetRadiusRect(tmpXLoc,TmpYLoc,1.0,0,DrwRect);}
   With DrwRect do     // Correct Horizontal Diameter of 10 miles
     Ellipse(Dc,TopLeftX,TopLeftY,BotRightX,BotRightY);

   { Draw a line diagonaly from bottom left to upper right }
   MoveToEx(Dc,Lon2Int(LonLeft),Lat2Int(LatBottom),NIL);
   LineTo(Dc,Lon2Int(LonRight),Lat2Int(LatTop));

   { Get the extents of a rectangle with a vertical side of 10 miles }
{   diff := GetRadiusRect(tmpXLoc,TmpYLoc,1.0,1,DrwRect);}
   With DrwRect do  // Correct Vertical Diameter  of 10 miles
     Ellipse(Dc,TopLeftX,TopLeftY,BotRightX,BotRightY);

   { Get the extents of a rectangle with each side = 10 miles }
{   diff := GetRadiusRect(tmpXLoc,TmpYLoc,1.0,2,DrwRect);}
   With DrwRect do
 // Correct Vert & Horiz Diameter but it's an egg if screen_aspect = 1
    Begin
     Ellipse(Dc,TopLeftX,TopLeftY,BotRightX,BotRightY);

     { Draw an Arrow on a 45 degree bearing }
     R := (BotRightY - TopLeftY) / 2;
     R1 := R +(R * 0.2);
     Bearing := 45;

     { Draw the shaft }
     X1 := Lon2Int(tmpXloc) + Round(Sin(DegToRad(Bearing))*R1);
     Y1 := Lat2Int(tmpYLoc) - Round(Cos(DegToRad(Bearing))*R1);
     MoveToEx(Dc,Lon2Int(tmpXloc),Lat2Int(tmpYLoc),NIL);
     LineTo(Dc,X1,Y1);

     { Draw one side of head }
     X2 := Lon2Int(tmpXloc) + Round(Sin(DegToRad(Bearing+15))*R);
     Y2 := Lat2Int(tmpYLoc) - Round(Cos(DegToRad(Bearing+15))*R);
     LineTo(Dc,X2,Y2);
     MoveToEx(Dc,X1,Y1,Nil);

     { Draw the other side of the head }
     X2 := Lon2Int(tmpXloc) + Round(Sin(DegToRad(Bearing-15))*R);
     Y2 := Lat2Int(tmpYLoc) - Round(Cos(DegToRad(Bearing-15))*R);
     LineTo(Dc,X2,Y2);
    End; // With DrwRect
      { Deselect and delete Pen }
   DeleteObject(SelectObject(Dc,hp));
   End;
 End;
end;

procedure TMOWMAP.SaveBitMapClick(Sender: TObject);
begin
 If SaveBmpDlg.Execute then
 with OlePmMap1 do
 Begin
  SaveToBitMap(SaveBmpDlg.FileName);
 End;

end;

procedure TMOWMAP.DDClick(Sender: TObject);
{Var dc : Hdc;  // See DirectDrawScaled}
begin
Try
 Screen.Cursor := CrHourGlass;
  with OlePmMap1,DirDrawFrm do
  Begin
   MapMode := 0;
   Caption := 'DirectDraw Not Scaled ';
   DirDrawImg.Width := OlePmMap1.Width div 4;   // Maintain aspect ratio
   DirDrawImg.Height := OlePmMap1.Height div 4;
   DirDrawFrm.Width := DirDrawImg.Width;
   DirDrawFrm.Height := DirDrawImg.Height+20;
   DirectDraw(DirDrawImg.Canvas.Handle,0,0,DirDrawImg.Width,
                        DirDrawImg.Height,True,False,True);  // Not Scaled Color
    Show;
  End;
 Finally
  Screen.Cursor := CrDefault;
 End;
end;

procedure TMOWMAP.DDSClick(Sender: TObject);
begin// Variation on DirectDraw.  Use Scaled bitmap & Handle of canvas
Try
 Screen.Cursor := CrHourGlass;
  with OlePmMap1,DirDrawFrm do
  Begin
   MapMode := 0;
   Caption := 'DirectDraw Scaled';
   DirDrawImg.Width := OlePmMap1.Width div 4;   // Maintain aspect ratio
   DirDrawImg.Height := OlePmMap1.Height div 4;
   DirDrawFrm.Width := DirDrawImg.Width;
   DirDrawFrm.Height := DirDrawImg.Height+20;
   DirectDraw(DirDrawImg.Canvas.Handle,0,0,DirDrawImg.Width,
                        DirDrawImg.Height,True,True,True);  //  Scaled
    Show;
  End;
 Finally
  Screen.Cursor := CrDefault;
 End;
end;



procedure TMOWMAP.SPClick(Sender: TObject);
Var Caps,Leftborder,topborder : Integer;
begin
// Print scaled bitmap using direct draw
Try
 with OlePmMap1 do
 Begin
  MapMode := 1;  // Clicks on map will be ignored
  Cursor := CrHourGlass;
  Screen.Cursor := CrHourGlass;
 End;
 Application.ProcessMessages;
 With Printer do
 Begin
   Caps := GetDeviceCaps(Printer.Handle,RasterCaps);
   if (Caps) And (RC_StretchBlt) = 0 then begin
     MessageDlg('Printer Test Failed',mtInformation,[mbIgnore],0);
     exit end; // Prn can't StretchBlt
   Leftborder := PageWidth div 4;
   Topborder := PageHeight div 4;
   BeginDoc;  // Print half width of page and Half the height
    OlePmMap1.DirectDraw(Printer.Canvas.Handle,LeftBorder,TopBorder,
                        Pagewidth div 2,PageHeight div 2,True,True,true);
   EndDoc;
 End;
Finally
 Screen.Cursor := CrDefault;
 OlePmMap1.MapMode := 0;
End;
end;

procedure TMOWMAP.NSPClick(Sender: TObject);
Var {Caps,}Leftborder,topborder : Integer;
begin
Try
 with OlePmMap1 do
 Begin
  MapMode := 1;
  Cursor := CrHourGlass;
  Screen.Cursor := CrHourGlass;
 End;
 Application.ProcessMessages;
With Printer do
 Begin
(*  Caps := GetDeviceCaps(Printer.Handle,RasterCaps);
   if (Caps) And (RC_StretchBlt) = 0 then begin
        MessageDlg('Printer Test Failed',mtInformation,[mbIgnore],0);
    exit end; // Prn can't StretchBlt
*)
  Leftborder := 0;
  Topborder :=0;
  BeginDoc;  // Print Map half width of page and Half the height
   OlePmMap1.DirectDraw(Printer.Canvas.Handle,LeftBorder,TopBorder,
                       OlePmMap1.Width{*2},OlePmMap1.Height{*2},True,False,True);
  EndDoc;
 End;
Finally
 Screen.Cursor := CrDefault;
 OlePmMap1.MapMode := 0;
End;
end;

procedure TMOWMAP.MemoryPrintClick(Sender: TObject);
Var {Caps,}Leftborder,topborder : Integer;Xmiles:Double;
begin
XMiles:=OlePmMap1.Miles;
Try
 with OlePmMap1 do
 Begin
  MapMode := 1;
  Cursor := CrHourGlass;
  Screen.Cursor := CrHourGlass;
  OlePmMap1.Miles:=0.03;
 End;
 Application.ProcessMessages;
With Printer do
 Begin
  Leftborder := 0;
  Topborder :=0;        {Landscape... so turned}
  Printer.Orientation := poLandscape;
  BeginDoc;  // Print Map half width of page and Half the height
   OlePmMap1.DirectDraw(Printer.Canvas.Handle,LeftBorder,TopBorder,
                       3300{OlePmMap1.Width*2},2400{OlePmMap1.Height*2},
                       True,False,False);
  EndDoc;
 End;
Finally
 OlePmMap1.Miles:=XMiles;
 Screen.Cursor := CrDefault;
 OlePmMap1.MapMode := 0;
End;
end;


procedure TMOWMAP.PrSetClick(Sender: TObject);
begin
 PrinterSetupDialog1.Execute;
end;


procedure TMOWMAP.OlePmMap1Direct(Sender: TObject; dc: Integer);
Var
     tmpxLoc,tmpyLoc{,diff} : Double;
     DrwRect : LLRect;
     caps : Integer;
      hp : Hpen;
begin DONOTDO:=FALSE;
{ Direct draw event.  All drawing is sent to dc }
If Printer.Printing then
Begin  { Direct draw can be used to print the map }
 Caps := GetDeviceCaps(Printer.Canvas.Handle,Rastercaps);
 if (Caps) And (RC_StretchBlt) = 0 then exit;  // Prn can't do StretchBlt
End;

 If DONOTDO {DrawOnMap1.Checked} then   // Menu selection
  with OlePmMap1 do
   Begin
   { Create and select a blue pen }
   hp := CreatePen(0,1,RGB(0,0,$ff));
   hp := SelectObject(Dc,hp);

   { Draw a line }
   MoveToEx(Dc,Lon2Int(LonLeft),Lat2Int(LatBottom),NIL);
   LineTo(Dc,Lon2Int(LonRight),Lat2Int(LatTop));

   { Deselect and delete Pen }
   DeleteObject(SelectObject(Dc,hp));
  End;  // DrawOnMap1.Checked

  If DONOTDO {DrawBubbleOnMap1.Checked }then
   with OlePmMap1 do
   Begin

    tmpxLoc := (LonLeft + LonRight) / 2; // Center of screen
    tmpyLoc := (LatTop + LatBottom) / 2;
    Drawbubble(Dc,tmpXloc,tmpYLoc,'Which Ellipse is 1 miles in diameter?');

     // Draw a Ellipse on the screen with no fill
     SetRop2(dc,R2_NotXorPen);

 {   diff := GetRadiusRect(tmpXLoc,TmpYLoc,1.0,0,DrwRect);  }
    With DrwRect do // Correct Horiz Diameter of 10 miles & Screen_Aspect =1
       Ellipse(Dc,TopLeftX,TopLeftY,BotRightX,BotRightY);

   { diff := GetRadiusRect(tmpXLoc,TmpYLoc,1.0,1,DrwRect); }
    With DrwRect do // Correct Vert Diameter of 10 miles  & Screen_Aspect =1
       Ellipse(Dc,TopLeftX,TopLeftY,BotRightX,BotRightY);

    {diff := GetRadiusRect(tmpXLoc,TmpYLoc,1.0,2,DrwRect);}
    With DrwRect do // Correct Vert & Horiz Diameter but it's an egg  & Screen_Aspect =1
       Ellipse(Dc,TopLeftX,TopLeftY,BotRightX,BotRightY);
       // Change Screen_Aspect to .8 to see this ellipse as a circle.
  End;
end;

procedure TMOWMAP.APIClick(Sender: TObject);
var dc : Hdc;
    ln,lt : Integer;
begin   // Demonstrates Win Api Calls
  Dc := GetDc(OlePmMap1.handle);

Try
 with OlePmMap1 do
 Begin
  ln := Width div 2;                // Map width in pixels  div 2
  ln := ln - (Image1.width div 2);  // Center x by moving left

  lt := Height div 2;               // Map Height in pixels div 2


  // Draw a line from lower left to upper right
  MoveToEx(dc,Lon2Int(LonLeft),Lat2Int(LatBottom),Nil);
  LineTo(dc,Lon2Int(lonRight),Lat2Int(LatTop));

  // Place a bitmap over the line in the center of the map
  BitBlt(Dc,ln,lt,Image1.Width,Image1.Height,Image1.canvas.handle,0,0,SrcCopy)

 End; // With OlePmMap1
Finally
  ReleaseDc(OlePmMap1.Handle,Dc);  // o NOT forget this
End;
end;

procedure TMOWMAP.ClearitClick(Sender: TObject);
begin{Clear the location widget}
 With OlePmMap1 do
 Begin
  ClrStrBubble; // Clears bubbles on screen set by ExecStreet
  Redraw;
 End;
end;


procedure TMOWMAP.ItemClick(Sender: TObject);
begin
 ItemFrm.ShowModal;
end;





end.
