unit REMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls, ClipBrd,
  FMXUtils, ColorGrd, OleCtnrs;

type
  TEditRich = class(TForm)
    EditRichMenu: TMainMenu;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FilePrintItem: TMenuItem;
    FileExitItem: TMenuItem;
    EditUndoItem: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    HelpContentsItem: TMenuItem;
    HelpSearchItem: TMenuItem;
    HelpHowToUseItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    ToolBarPanel: TPanel;
    OpenButton: TSpeedButton;
    SaveButton: TSpeedButton;
    PrintButton: TSpeedButton;
    UndoButton: TSpeedButton;
    CutButton: TSpeedButton;
    CopyButton: TSpeedButton;
    PasteButton: TSpeedButton;
    Ruler: TPanel;
    Bevel1: TBevel;
    FontDialog1: TFontDialog;
    FirstInd: TLabel;
    LeftInd: TLabel;
    RulerLine: TBevel;
    RightInd: TLabel;
    N5: TMenuItem;
    RichEdit1: TRichEdit;
    StatusBar: TStatusBar;
    FindDialog1: TFindDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    View1: TMenuItem;
    Toolbar: TMenuItem;
    Statusbar1: TMenuItem;
    Formatbar: TMenuItem;
    Ruler1: TMenuItem;
    Insert: TMenuItem;
    DateTime: TMenuItem;
    InsertObject: TMenuItem;
    Formatit: TMenuItem;
    Paragraph: TMenuItem;
    Tabs: TMenuItem;
    Font1: TMenuItem;
    SelectAll: TMenuItem;
    Finder: TMenuItem;
    Replacer: TMenuItem;
    Setupit: TMenuItem;
    PasteSpecial: TMenuItem;
    Clearblocked: TMenuItem;
    FindNext: TMenuItem;
    N7: TMenuItem;
    MissingLinks: TMenuItem;
    ObjectProperties: TMenuItem;
    EditObject: TMenuItem;
    FormatBarPanel: TPanel;
    BoldButton: TSpeedButton;
    FontName: TComboBox;
    FontSize: TEdit;
    UpDown1: TUpDown;
    ItalicButton: TSpeedButton;
    UnderlineButton: TSpeedButton;
    FontSelectBtn: TSpeedButton;
    LeftAlign: TSpeedButton;
    CenterAlign: TSpeedButton;
    RightAlign: TSpeedButton;
    BulletsButton: TSpeedButton;
    NewButton: TSpeedButton;
    PrintSetupBtn: TSpeedButton;
    FinderBtn: TSpeedButton;
    InsertDateTimeBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    ParagraphBtn: TSpeedButton;
    TabsBtn: TSpeedButton;
    InsertObjectBtn: TSpeedButton;
    ReplaceDialog1: TReplaceDialog;
    ReplaceBtn: TSpeedButton;
    PageFormat: TMenuItem;
    PageSetBtn: TSpeedButton;
    FontColor: TSpeedButton;
    ColorGrid1: TColorGrid;
    OleContainer1: TOleContainer;
    N9: TMenuItem;
    RunWordPad: TMenuItem;

    procedure SelectionChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FilePrint(Sender: TObject);
    procedure Printit;
    procedure FileExit(Sender: TObject);
    procedure EditUndo(Sender: TObject);
    procedure EditCut(Sender: TObject);
    procedure EditCopy(Sender: TObject);
    procedure EditPaste(Sender: TObject);
    procedure HelpContents(Sender: TObject);
    procedure HelpSearch(Sender: TObject);
    procedure HelpHowToUse(Sender: TObject);
    procedure HelpAbout(Sender: TObject);
    procedure SelectFont(Sender: TObject);
    procedure RulerResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure BoldButtonClick(Sender: TObject);
    procedure ItalicButtonClick(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure AlignButtonClick(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure UnderlineButtonClick(Sender: TObject);
    procedure BulletsButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure RulerItemMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RulerItemMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FirstIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LeftIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RightIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormatbarClick(Sender: TObject);
    procedure Ruler1Click(Sender: TObject);
    procedure ToolbarClick(Sender: TObject);
    procedure Statusbar1Click(Sender: TObject);
    procedure PrintSetupBtnClick(Sender: TObject);
    procedure FinderClick(Sender: TObject);
    procedure ReplacerClick(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure DoReplace;
    procedure DoReplaceAll(Sender: TObject);
    procedure InsertDateTimeBtnClick(Sender: TObject);
    procedure InsertObjectBtnClick(Sender: TObject);
    procedure ParagraphBtnClick(Sender: TObject);
    procedure TabsBtnClick(Sender: TObject);
    procedure PasteSpecialClick(Sender: TObject);
    procedure ClearblockedClick(Sender: TObject);
    procedure SelectAllClick(Sender: TObject);
    procedure FindNextClick(Sender: TObject);
    procedure MissingLinksClick(Sender: TObject);
    procedure ObjectPropertiesClick(Sender: TObject);
    procedure EditObjectClick(Sender: TObject);
    procedure PageFormatClick(Sender: TObject);
    procedure Label1mMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RulerClick(Sender: TObject);
    procedure FontColorClick(Sender: TObject);
    procedure ColorGrid1Click(Sender: TObject);
    procedure OleContainer1ObjectMove(OleContainer: TOleContainer;
      const Bounds: TRect);
    procedure RunWordPadClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);

  private
    FFileName: String;
    FUpdating: Boolean;
    FDragOfs: Integer;
    FDragging: Boolean;
    function CurrText: TTextAttributes;
    procedure GetFontNames;
    procedure SetFileName(const FileName: String);
    procedure CheckFileSave;
    procedure SetupRuler;
    procedure SetEditRect;
{  end;}
  public
procedure DoFrozenRTF;
procedure DoDailySummary(IsDaily:Boolean);
procedure DoDepositSummary;
procedure DoDepositDueSummary(IsWeekly:Boolean);
procedure DoMealCount;
procedure DoMOWDates;

   end;
var
  EditRich: TEditRich;
const
  RulerAdj = 4/3;
  GutterWid = 6;

implementation

uses { Mowmain,}
DataMod, RETabSet, REParagraph, REPageSetup, REAbout;

var
ToFind: string;        {String to find}
FindIn: string;        {String to search}
Found: integer;        {String found indicator}
{Index: integer;  }      {Start pos. of found text}
{FoundText: string; }    {String to be replaced}
FoundLen: integer;     {Length of found text}
NotFound,DidFind: boolean;      {Flags if Find runs before Replace}


{$R *.DFM}

procedure TEditRich.FileExit(Sender: TObject);
begin
  Close;
  OleContainer1.DestroyObject;
end;
procedure TEditRich.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    CheckFileSave;
  except
    CanClose := False;
  end;
end;

procedure TEditRich.CheckFileSave;
var
  SaveResp: Integer;
begin
  if not RichEdit1.Modified then Exit;
  SaveResp := MessageDlg(Format('Save changes to %s?', [FFileName]),
    mtConfirmation, mbYesNoCancel, 0);
  case SaveResp of
    idYes: FileSave(Self);
    idNo: {Nothing};
    idCancel: Abort;
  end;
end;


procedure TEditRich.SelectionChange(Sender: TObject);
begin
  with RichEdit1.Paragraph do
  try
    FUpdating := True;
    FirstInd.Left := Trunc(FirstIndent*RulerAdj)-4+GutterWid;
    LeftInd.Left := Trunc((LeftIndent+FirstIndent)*RulerAdj)-4+GutterWid;
    RightInd.Left := Ruler.ClientWidth-6-Trunc((RightIndent+GutterWid)*RulerAdj);
    BoldButton.Down := fsBold in RichEdit1.SelAttributes.Style;
    ItalicButton.Down := fsItalic in RichEdit1.SelAttributes.Style;
    UnderlineButton.Down := fsUnderline in RichEdit1.SelAttributes.Style;
    BulletsButton.Down := Boolean(Numbering);
    FontSize.Text := IntToStr(RichEdit1.SelAttributes.Size);
    FontName.Text := RichEdit1.SelAttributes.Name;
    case Ord(Alignment) of
      0: LeftAlign.Down := True;
      1: RightAlign.Down := True;
      2: CenterAlign.Down := True;
    end;
    SetupRuler;
  finally
    FUpdating := False;
  end;
end;
procedure TEditRich.SetupRuler;
var  {Charit:Char;}
  I{,I2N}: Integer;
  S{,I2S}: String;
begin
  Ruler.Font.Size := RichEdit1.SelAttributes.Size;
  Ruler.Font.Name := RichEdit1.SelAttributes.Name;
  SetLength(S, 52);
  I := 0; { I2N:=1;}
  while I < 51 do
  begin
    Inc(I);
    S[I] := #9;  {Tab character}
    Inc(I);
    S[I] := '|';
{    str(I2N,I2S); Charit:=I2S[1];
    S[I+1] :=Charit;}
{    Inc(I2N);}
  end;
  Ruler.Caption := S;
end;

function TEditRich.CurrText: TTextAttributes;
begin
  if RichEdit1.SelLength > 0 then
    Result := RichEdit1.SelAttributes
  else
    Result := RichEdit1.DefAttributes;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
end;

procedure TEditRich.GetFontNames;
var
  DC: HDC;
begin
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(FontName.Items));
  ReleaseDC(0, DC);
  FontName.Sorted := True;
end;

procedure TEditRich.SetFileName(const FileName: String);
begin
  FFileName := FileName;
  Caption := Format('%s - %s', [ExtractFileName(FileName), Application.Title]);
end;



procedure TEditRich.SetEditRect;
var
  R: TRect;
begin
  with RichEdit1 do
  begin
    R := Rect(GutterWid, 0, ClientWidth-GutterWid, ClientHeight);
    SendMessage(Handle, EM_SETRECT, 0, Longint(@R));
  end;
end;

{ Event Handlers }

procedure TEditRich.FormCreate(Sender: TObject);
begin
  OpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
  SaveDialog.InitialDir := OpenDialog.InitialDir;
  SetFileName('Untitled');
  GetFontNames;
  SetupRuler;
  SelectionChange(Self);
  Left := 180;
  Top := 141;
end;
{procedure TEditRich.ShowRTFHint(Sender: TObject);
begin
end;

 TEditRich.ShowRTFHint
  StatusBar.SimpleText := '   '+Application.Hint;}
{ TEditRich.FormShow(
 Application.OnHint := ShowRTFHint;}
 {TEditRich.FormClose
  Application.OnHint := Main.ShowHint;}

procedure TEditRich.FileNew(Sender: TObject);
begin
  SetFileName('Untitled');
  RichEdit1.Lines.Clear;
  RichEdit1.Modified := False;
end;

procedure TEditRich.FileOpen(Sender: TObject);
begin
  CheckFileSave;
  if OpenDialog.Execute then
  begin
    RichEdit1.Lines.LoadFromFile(OpenDialog.FileName);
    SetFileName(OpenDialog.FileName);
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
    RichEdit1.ReadOnly := ofReadOnly in OpenDialog.Options;
  end;
end;

procedure TEditRich.FileSave(Sender: TObject);
begin
  if FFileName = 'Untitled' then
    FileSaveAs(Sender)
  else
  begin
    RichEdit1.Lines.SaveToFile(FFileName);
    RichEdit1.Modified := False;
  end;
end;

procedure TEditRich.FileSaveAs(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    if FileExists(SaveDialog.FileName) then
      if MessageDlg(Format('OK to overwrite %s', [SaveDialog.FileName]),
        mtConfirmation, mbYesNoCancel, 0) <> idYes then Exit;
    RichEdit1.Lines.SaveToFile(SaveDialog.FileName);
    SetFileName(SaveDialog.FileName);
    RichEdit1.Modified := False;
  end;
end;
procedure TEditRich.RunWordPadClick(Sender: TObject);
begin
    ExecuteFile('Wordpad.exe'{'MOWFF.wpd'}, '', 'F:\mow\source', SW_SHOW);
end;

procedure TEditRich.FilePrint(Sender: TObject);
begin
  if PrintDialog.Execute then Printit;
end;
procedure TEditRich.Printit;
begin
    RichEdit1.Print(FFileName);
end;

procedure TEditRich.PrintSetupBtnClick(Sender: TObject);
begin
{}PrinterSetupDialog1.Execute;
end;


procedure TEditRich.EditUndo(Sender: TObject);
begin
  with RichEdit1 do
    if HandleAllocated then SendMessage(Handle, EM_UNDO, 0, 0);
end;

procedure TEditRich.EditCut(Sender: TObject);
begin
  RichEdit1.CutToClipboard;
end;

procedure TEditRich.EditCopy(Sender: TObject);
begin
  RichEdit1.CopyToClipboard;
end;

procedure TEditRich.EditPaste(Sender: TObject);
begin
  RichEdit1.PasteFromClipboard;
end;

procedure TEditRich.HelpBtnClick(Sender: TObject);
begin
 Application.HelpContext(2400);
end;

procedure TEditRich.HelpContents(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TEditRich.HelpSearch(Sender: TObject);
const
  EmptyString: PChar = '';
begin
  Application.HelpCommand(HELP_PARTIALKEY, Longint(EmptyString));
end;

procedure TEditRich.HelpHowToUse(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;

procedure TEditRich.HelpAbout(Sender: TObject);
begin
{  with TEditAbout.Create(Self) do
  try}
    ShowModal;
{  finally
    Free;
  end;}
end;


procedure TEditRich.RulerResize(Sender: TObject);
begin
  RulerLine.Width := Ruler.ClientWidth - (RulerLine.Left*2);
end;

procedure TEditRich.FormResize(Sender: TObject);
begin
  SetEditRect;
  SelectionChange(Sender);
end;

procedure TEditRich.FormPaint(Sender: TObject);
begin
  SetEditRect;
end;

procedure TEditRich.BoldButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if BoldButton.Down then
    CurrText.Style := CurrText.Style + [fsBold]
  else
    CurrText.Style := CurrText.Style - [fsBold];
end;

procedure TEditRich.ItalicButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if ItalicButton.Down then
    CurrText.Style := CurrText.Style + [fsItalic]
  else
    CurrText.Style := CurrText.Style - [fsItalic];
end;

procedure TEditRich.FontSizeChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Size := StrToInt(FontSize.Text);
end;

procedure TEditRich.AlignButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  RichEdit1.Paragraph.Alignment := TAlignment(TControl(Sender).Tag);
end;

procedure TEditRich.FontNameChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Name := FontName.Items[FontName.ItemIndex];
end;

procedure TEditRich.UnderlineButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if UnderlineButton.Down then
    CurrText.Style := CurrText.Style + [fsUnderline]
  else
    CurrText.Style := CurrText.Style - [fsUnderline];
end;

procedure TEditRich.BulletsButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  RichEdit1.Paragraph.Numbering := TNumberingStyle(BulletsButton.Down);
end;


{ Ruler Indent Dragging }

procedure TEditRich.RulerItemMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragOfs := (TLabel(Sender).Width div 2);
  TLabel(Sender).Left := TLabel(Sender).Left+X-FDragOfs;
  FDragging := True;
end;

procedure TEditRich.RulerItemMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if FDragging then
    TLabel(Sender).Left :=  TLabel(Sender).Left+X-FDragOfs
end;

procedure TEditRich.FirstIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  RichEdit1.Paragraph.FirstIndent := Trunc((FirstInd.Left+FDragOfs-GutterWid) / RulerAdj);
  LeftIndMouseUp(Sender, Button, Shift, X, Y);
end;

procedure TEditRich.LeftIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  RichEdit1.Paragraph.LeftIndent := Trunc((LeftInd.Left+FDragOfs-GutterWid) / RulerAdj)-RichEdit1.Paragraph.FirstIndent;
  SelectionChange(Sender);
end;

procedure TEditRich.RightIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  RichEdit1.Paragraph.RightIndent := Trunc((Ruler.ClientWidth-RightInd.Left+FDragOfs-2) / RulerAdj)-2*GutterWid;
  SelectionChange(Sender);
end;

procedure TEditRich.FormatbarClick(Sender: TObject);
begin
Formatbar.Checked:= (not Formatbar.Checked);
FormatBarPanel.Visible:= (Not FormatBarPanel.Visible);
end;

procedure TEditRich.Ruler1Click(Sender: TObject);
begin
Ruler1.Checked:= (not Ruler1.Checked);
Ruler.Visible:= (Not Ruler.Visible);
end;

procedure TEditRich.ToolbarClick(Sender: TObject);
begin
Toolbar.Checked:= (not Toolbar.Checked);
ToolBarPanel.Visible:= (Not ToolBarPanel.Visible);
end;

procedure TEditRich.Statusbar1Click(Sender: TObject);
begin
Statusbar1.Checked:= (not Statusbar1.Checked);
StatusBar.Visible:= (Not StatusBar.Visible);
{    If (StatusBar.Visible) then Application.OnHint := ShowRTFHint
        else  Application.OnHint := Main.ShowHint;}
end;
(************************************************************)
(************************************************************)



(************************************************************)
(************************************************************)
procedure TEditRich.FinderClick(Sender: TObject);
begin
FindDialog1.FindText:= RichEdit1.SelText;
FindDialog1.Execute;
end;

procedure TEditRich.ReplacerClick(Sender: TObject);
begin
ReplaceDialog1.FindText:= RichEdit1.SelText;
NotFound:=True;
ReplaceDialog1.Execute;
end;

procedure TEditRich.ReplaceDialog1Find(Sender: TObject);
begin
ToFind := ReplaceDialog1.FindText;     {String from Find control}
FoundLen := Length(ReplaceDialog1.FindText); {Length of text}
FindIn := EditRich.RichEdit1.Text;               {Text to search for String}
Found := Pos(ToFind, FindIn);             {Search for the String}
If Found > 0 then
  begin
  EditRich.BringToFront;             {Edit control must have focus in}
  EditRich.ActiveControl := RichEdit1;    {order to display selected text}
RichEdit1.SetFocus;
  RichEdit1.SelStart:= Found -1;      {Select the string found by POS}
  RichEdit1.SelLength := FoundLen;
  end
Else
  begin
  NotFound:=False;
  MessageDlg('Text not found', mtInformation, [mbOK], 0);
  end;

end;

procedure TEditRich.ReplaceDialog1Replace(Sender: TObject);
begin
If DidFind = False then       {If no search for string took place}
  begin
  ReplaceDialog1Find(Sender); {Search for string, replace if found}
  if (ReplaceDialog1.Options*[frReplace])=[frReplace] then DoReplace
  else if (ReplaceDialog1.Options*[frReplaceAll])=[frReplaceAll] then DoReplaceAll(Sender);
  end
Else                          {If search ran, replace string}
  begin
  if (ReplaceDialog1.Options*[frReplace])=[frReplace] then DoReplace
  else if (ReplaceDialog1.Options*[frReplaceAll])=[frReplaceAll] then DoReplaceAll(Sender);
  end;
end;

procedure TEditRich.DoReplace;
begin
  RichEdit1.SelText := ReplaceDialog1.ReplaceText;
  ReplaceDialog1.CloseDialog;
end;



procedure TEditRich.DoReplaceAll(Sender: TObject);
{Index: integer;  }      {Start pos. of found text}
{FoundText: string; }    {String to be replaced}
begin
While (NotFound = True)do
begin
  ReplaceDialog1Find(Sender); {Search for string, replace if found}
  If Found > 0 then RichEdit1.SelText := ReplaceDialog1.ReplaceText;
end;
  ReplaceDialog1.CloseDialog;
end;

procedure TEditRich.FindDialog1Find(Sender: TObject);
begin
ToFind := FindDialog1.FindText;     {User specified string in dialog}
FoundLen := Length(FindDialog1.FindText); {Length of specified text}
FindIn := EditRich.RichEdit1.Text;      {Text to search for string}
{if (FindDialog1.Options*[frDown])=[frDown] then SearchDown
else SearchUp;}
Found := Pos(ToFind, FindIn);    {Search for string}
If Found > 0 then
  begin
  FindDialog1.CloseDialog;
  EditRich.BringToFront;             {Edit control must have focus in}
  EditRich.ActiveControl := RichEdit1;  { order to display selected text}
RichEdit1.SetFocus;
  RichEdit1.SelStart:= Found -1;      {Select the string found by POS}
  RichEdit1.SelLength := FoundLen;
  end
Else
  begin
  MessageDlg('Text not found', mtInformation, [mbOK], 0);
  end;
end;
procedure TEditRich.FindNextClick(Sender: TObject);
begin
FindDialog1.FindText:= RichEdit1.SelText;
ToFind := FindDialog1.FindText;     {User specified string in dialog}
FoundLen := Length(FindDialog1.FindText); {Length of specified text}
FindIn := EditRich.RichEdit1.Text;      {Text to search for string}
{if (FindDialog1.Options*[frDown])=[frDown] then SearchDown
else SearchUp;}
Found := Pos(ToFind, FindIn);    {Search for string}
If Found > 0 then
  begin
  FindDialog1.CloseDialog;
  EditRich.BringToFront;             {Edit control must have focus in}
  EditRich.ActiveControl := RichEdit1;  { order to display selected text}
  RichEdit1.SetFocus;
  RichEdit1.SelStart:= Found -1;      {Select the string found by POS}
  RichEdit1.SelLength := FoundLen;
  end
Else
  begin
  MessageDlg('Text not found', mtInformation, [mbOK], 0);
  end;
end;

(*  Example                               string
The following OnFind event handler searches a memo component for
the text specified in the FindText property of a find dialog component.
If found, the first occurrence of the text in Memo1 is selected.
The code uses the Pos function to compare strings,
and stores the number of characters to skip when determining
the selection position in the SkipChars variable.
Because there is no handling of case, whole word, or search direction
in this algorithm, it is assumed that the Options property of FindDialog1
 was set to [frHideMatchCase, frHideWholeWord, frHideUpDown].

 AnsiCompareStr	Performs a case sensitive compare of two strings.
AnsiCompareText	Performs a non-case sensitive compare of two strings.
CompareStr	Performs a case sensitive compare of two strings
CompareText	Performs a non-case sensitive compare of two strings

procedure TForm1.FindDialog1Find(Sender: TObject);
var
  I, J, PosReturn, SkipChars: Integer;
begin
  For I := 0 to Memo1.Lines.Count do
  begin
    PosReturn := Pos(FindDialog1.FindText,Memo1.Lines[I]);
    if PosReturn <> 0 then {found!}
      begin
        Skipchars := 0;
        for J := 0 to I - 1 do
          Skipchars := Skipchars + Length(Memo1.Lines[J]);
        SkipChars := SkipChars + (I*2);
        SkipChars := SkipChars + PosReturn - 1;
        Memo1.SetFocus;
        Memo1.SelStart := SkipChars;
        Memo1.SelLength := Length(FindDialog1.FindText);
      end;
  end;
end;
*)
(************************************************************)
(************************************************************)
(************************************************************)
{
  MessageDlg('This is impossible- Nothing werks around here',
  mtInformation,[mbOK],0)
}
(************************************************************)
procedure TEditRich.InsertDateTimeBtnClick(Sender: TObject);
begin
  if RichEdit1.SelLength > 0 then RichEdit1.SelText:=DateToStr(Date)
  else
    RichEdit1.SelText:=DateToStr(Date);
end;

procedure TEditRich.InsertObjectBtnClick(Sender: TObject);
begin
  If OleContainer1.InsertObjectDialog then  begin
     OleContainer1.Visible:=True;
     ObjectProperties.Enabled:=True;
     If OleContainer1.Linked then MissingLinks.Enabled:=True
     else EditObject.Enabled:=True;
     MessageDlg('This is implossible:'+#13#10+
                'Nothing werks around here'+#13#10+
                'You will be sorry'+#13#10+
                'Objects do Not print'+#13#10+
                'Run WordPad from File Menu...', mtInformation,[mbOK],0)
     end;
end;

procedure TEditRich.SelectFont(Sender: TObject);
begin
  FontDialog1.Font.Assign(RichEdit1.SelAttributes);
  if FontDialog1.Execute then
    CurrText.Assign(FontDialog1.Font);
  RichEdit1.SetFocus;
end;

procedure TEditRich.TabsBtnClick(Sender: TObject);
begin
RETabSetter.ShowModal;
end;
procedure TEditRich.ParagraphBtnClick(Sender: TObject);
begin
REParaSet.ShowModal;
end;
procedure TEditRich.PageFormatClick(Sender: TObject);
begin
REPageSet.ShowModal;
end;


procedure TEditRich.PasteSpecialClick(Sender: TObject);
begin
OleContainer1.PasteSpecialDialog;
end;

procedure TEditRich.ClearblockedClick(Sender: TObject);
begin
  if RichEdit1.SelLength > 0 then RichEdit1.SelText:=''
  else begin
    RichEdit1.SelText:=' ';
    RichEdit1.SelStart :=RichEdit1.SelStart-1;
    RichEdit1.SelLength := RichEdit1.SelLength+2;
    RichEdit1.SelText:=''
  end;
end;

procedure TEditRich.SelectAllClick(Sender: TObject);
begin
  RichEdit1.SetFocus;
  RichEdit1.SelectAll;
  end;


procedure TEditRich.MissingLinksClick(Sender: TObject);
begin
OleContainer1.DoVerb(ovPrimary)
end;

procedure TEditRich.ObjectPropertiesClick(Sender: TObject);
begin
OleContainer1.ObjectPropertiesDialog;
end;

procedure TEditRich.EditObjectClick(Sender: TObject);
begin
OleContainer1.DoVerb(ovPrimary)
end;

(************************************************************)
(************************************************************)
 { MessageDlg('This is impossible- Nothing werks around here'+#13#10+
             'Ternminate the application?',mtInformation,[mbOK],0);
}
(************************************************************)
(************************************************************)



{  RichEdit1.Font.Name := 'Times New Roman';
  RichEdit1.Font.Style := [fsBold] + [fsUnderline];
  RichEdit1.Font.Size := 12;
  RichEdit1.Font.Color := clBlack;
    RichEdit1.Font.Style := RichEdit1.Font.Style - [fsBold];
    RichEdit1.Font.Style := RichEdit1.Font.Style - [fsUnderline];
WorkingString:= RichEdit1.Lines[0];
}
(************************************************************)
(************************************************************)


(************************************************************)
(************************************************************)
procedure  TEditRich.DoFrozenRTF;
var
{PDString, for Sat and Sun FF}DayString,WorkingString:String;
BlankCount,Countess,Longer,CountDracula,TotalMeals,
LineKeeper,MealCount,LineCount,Lounger,I:Integer;
Begin
{Count and if not over full then delete lines to keep on 1 page}
    RichEdit1.Lines.LoadFromFile('MOW12FF_Base.RTF');
    DayString:= FormatDateTime('dmmmyy', Date);
    SetFileName('MOW12FF_'+DayString+'.RTF');
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
    WorkingString:= '  MOW12FF_'+DayString+'.RTF';
    DayString:= FormatDateTime('d  mmm, yyyy', Date);
    RichEdit1.Lines[1]:= WorkingString+
    '                                             '+
    '                                        as of: '+
    DayString;

{DayString used for naught and all else}
MOWZDB.FoodOrderTable.First;
WorkingString:=RichEdit1.Lines[3];
DayString:=MOWZDB.FoodOrderTable['HContact1'];
WorkingString:= (WorkingString+DayString);
RichEdit1.Lines[3]:=WorkingString;
WorkingString:=RichEdit1.Lines[4];
DayString:=MOWZDB.FoodOrderTable['HContact2'];
WorkingString:= (WorkingString+DayString);
RichEdit1.Lines[4]:=WorkingString;

MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFHEAD.db';
MOWZDB.DSRTable.Active := True;
MOWZDB.DSRTable.First;
WorkingString:= MOWZDB.DSRTable['DateStuff'];
RichEdit1.Lines[5]:=WorkingString;
MOWZDB.DSRTable.Next;
WorkingString:= MOWZDB.DSRTable['DateStuff'];
RichEdit1.Lines[6]:=WorkingString;

{Load FFSR}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFSR.db';
MOWZDB.DSRTable.Active := True;
LineKeeper:=10;
MealCount:=0;
TotalMeals:=0;
LineCount:=10;   {total lines}
Countess:=0;    {Client lines}
CountDracula:=10; {Report: NOT ERASABLE lines}
BlankCount:=16;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      inc(Countess);
      inc(MealCount);
      WorkingString:= ' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['Route']+'    ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['SorD']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do
          begin
          WorkingString:= (WorkingString+' ');
          end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do
           begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(53- Length(WorkingString));
      For I:= 0 to Longer do
          begin WorkingString:= (WorkingString+' ');end;
      DayString:=MOWZDB.DSRTable['Diet Memo'];
      If (Length(DayString) > 21) then begin
      WorkingString:= WorkingString+Copy(DayString,1,21);
      RichEdit1.Lines[LineCount]:=WorkingString;
      inc(LineCount);
      inc(Countess);
      WorkingString:= ('    '+Copy(DayString,22,70) );
      end else WorkingString:= WorkingString+ DayString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{MUST KNOW how many lines there should be as MAX
then delete the extra Client lines as they are not used}
Lounger:= (BlankCount-LineCount);
LineCount:=(LineCount+Lounger );
For I:=1 to Lounger do begin
      RichEdit1.Lines.Delete((LineCount));
      dec(LineCount);
      end;
If ( (Countess + CountDracula) <> LineCount) then
 MessageDlg('Frozen meltdown',mtInformation,[mbOK],0);
inc(LineCount);inc(Countess);
RichEdit1.Lines.Insert(LineCount, '  ');
{Always have a blank}
inc(CountDracula);
inc(LineCount);
BlankCount:=LineCount+6;
   WorkingString:= RichEdit1.Lines[LineKeeper];
   str(MealCount,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   If (MealCount = 0) then WorkingString:=' ';
   RichEdit1.Lines[LineKeeper]:=WorkingString;
   LineKeeper:=LineCount;TotalMeals:=(TotalMeals+ MealCount);MealCount:=0;

{Load FFSLS}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFSLS.db';
MOWZDB.DSRTable.Active := True;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      inc(Countess);
      inc(MealCount);
      WorkingString:= ' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['Route']+'    ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['SorD']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(53- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      DayString:=MOWZDB.DSRTable['Diet Memo'];
      If (Length(DayString) > 21) then begin
      WorkingString:= WorkingString+Copy(DayString,1,21);
      RichEdit1.Lines[LineCount]:=WorkingString;
      inc(LineCount);inc(Countess);
      WorkingString:= ('    '+Copy(DayString,22,70) );
      end else WorkingString:= WorkingString+ DayString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{MUST KNOW how many lines there should be as MAX
then delete the extra Client lines as they are not used}
Lounger:= (BlankCount-LineCount);
LineCount:=(LineCount+Lounger );
For I:=1 to Lounger do begin
      RichEdit1.Lines.Delete((LineCount));
      dec(LineCount);
      end;
If ( (Countess + CountDracula) <> LineCount) then
 MessageDlg('Frozen meltdown',mtInformation,[mbOK],0);
inc(LineCount);
inc(Countess);
RichEdit1.Lines.Insert(LineCount, '  ');
{Always have a blank}
inc(CountDracula);
inc(LineCount);
BlankCount:=LineCount+6;
   WorkingString:= RichEdit1.Lines[LineKeeper];
   str(MealCount,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   If (MealCount = 0) then WorkingString:=' ';
   RichEdit1.Lines[LineKeeper]:=WorkingString;
   LineKeeper:=LineCount;
   TotalMeals:=(TotalMeals+ MealCount);
   MealCount:=0;


{Load FFSD}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFSD.db';
MOWZDB.DSRTable.Active := True;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      inc(Countess);
      inc(MealCount);
      WorkingString:= ' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['Route']+'    ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['SorD']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(53- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      DayString:=MOWZDB.DSRTable['Diet Memo'];
      If (Length(DayString) > 21) then begin
      WorkingString:= WorkingString+Copy(DayString,1,21);
      RichEdit1.Lines[LineCount]:=WorkingString;
      inc(LineCount);inc(Countess);
      WorkingString:= ('    '+Copy(DayString,22,70) );
      end else WorkingString:= WorkingString+ DayString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{MUST KNOW how many lines there should be as MAX
then delete the extra Client lines as they are not used}
Lounger:= (BlankCount-LineCount);LineCount:=(LineCount+Lounger );
For I:=1 to Lounger do begin
      RichEdit1.Lines.Delete((LineCount));
      dec(LineCount);
      end;
If ( (Countess + CountDracula) <> LineCount) then
 MessageDlg('Frozen meltdown',mtInformation,[mbOK],0);
inc(LineCount);inc(Countess);
RichEdit1.Lines.Insert(LineCount, '  ');
{Always have a blank}
inc(CountDracula);inc(LineCount);BlankCount:=LineCount+6;
   WorkingString:= RichEdit1.Lines[LineKeeper];
   str(MealCount,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   If (MealCount = 0) then WorkingString:=' ';
   RichEdit1.Lines[LineKeeper]:=WorkingString;
   LineKeeper:=LineCount;TotalMeals:=(TotalMeals+ MealCount);MealCount:=0;


{Load FFSDS}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFSDS.db';
MOWZDB.DSRTable.Active := True;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);inc(Countess);inc(MealCount);
      WorkingString:= ' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['Route']+'    ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['SorD']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(53- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      DayString:=MOWZDB.DSRTable['Diet Memo'];
      If (Length(DayString) > 21) then begin
      WorkingString:= WorkingString+Copy(DayString,1,21);
      RichEdit1.Lines[LineCount]:=WorkingString;
      inc(LineCount);inc(Countess);
      WorkingString:= ('    '+Copy(DayString,22,70) );
      end else WorkingString:= WorkingString+ DayString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{MUST KNOW how many lines there should be as MAX
then delete the extra Client lines as they are not used}
Lounger:= (BlankCount-LineCount);LineCount:=(LineCount+Lounger );
For I:=1 to Lounger do begin
      RichEdit1.Lines.Delete((LineCount));
      dec(LineCount);
      end;
If ( (Countess + CountDracula) <> LineCount) then
 MessageDlg('Frozen meltdown',mtInformation,[mbOK],0);
inc(LineCount);inc(Countess);
RichEdit1.Lines.Insert(LineCount, '  ');
{Always have a blank}
inc(CountDracula);inc(LineCount);inc(CountDracula);inc(LineCount);
inc(CountDracula);inc(LineCount);BlankCount:=LineCount+6;
   WorkingString:= RichEdit1.Lines[LineKeeper];
   str(MealCount,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   If (MealCount = 0) then WorkingString:=' ';
   RichEdit1.Lines[LineKeeper]:=WorkingString;
   LineKeeper:=LineCount;TotalMeals:=(TotalMeals+ MealCount);MealCount:=0;


{Load FFSSR}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFSSR.db';
MOWZDB.DSRTable.Active := True;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);inc(Countess); inc(MealCount);
      WorkingString:= ' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['Route']+'    ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['SorD']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(53- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      DayString:=MOWZDB.DSRTable['Diet Memo'];
      If (Length(DayString) > 21) then begin
      WorkingString:= WorkingString+Copy(DayString,1,21);
      RichEdit1.Lines[LineCount]:=WorkingString;
      inc(LineCount);inc(Countess);
      WorkingString:= ('    '+Copy(DayString,22,70) );
      end else WorkingString:= WorkingString+ DayString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{MUST KNOW how many lines there should be as MAX
then delete the extra Client lines as they are not used}
Lounger:= (BlankCount-LineCount);LineCount:=(LineCount+Lounger );
For I:=1 to Lounger do begin
      RichEdit1.Lines.Delete((LineCount));
      dec(LineCount);
      end;
If ( (Countess + CountDracula) <> LineCount) then
 MessageDlg('Frozen meltdown',mtInformation,[mbOK],0);
inc(LineCount);inc(Countess);
RichEdit1.Lines.Insert(LineCount, '  ');
{Always have a blank}
inc(CountDracula);inc(LineCount);BlankCount:=LineCount+6;
   WorkingString:= RichEdit1.Lines[LineKeeper];
   str(MealCount,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   If (MealCount = 0) then WorkingString:=' ';
   RichEdit1.Lines[LineKeeper]:=WorkingString;
   LineKeeper:=LineCount;TotalMeals:=(TotalMeals+ MealCount);MealCount:=0;


{Load FFSSLS}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFSSLS.db';
MOWZDB.DSRTable.Active := True;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);inc(Countess);  inc(MealCount);
      WorkingString:= ' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['Route']+'    ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['SorD']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(53- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      DayString:=MOWZDB.DSRTable['Diet Memo'];
      If (Length(DayString) > 21) then begin
      WorkingString:= WorkingString+Copy(DayString,1,21);
      RichEdit1.Lines[LineCount]:=WorkingString;
      inc(LineCount);inc(Countess);
      WorkingString:= ('    '+Copy(DayString,22,70) );
      end else WorkingString:= WorkingString+ DayString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{MUST KNOW how many lines there should be as MAX
then delete the extra Client lines as they are not used}
Lounger:= (BlankCount-LineCount);LineCount:=(LineCount+Lounger );
For I:=1 to Lounger do begin
      RichEdit1.Lines.Delete((LineCount));
      dec(LineCount);
      end;
If ( (Countess + CountDracula) <> LineCount) then
 MessageDlg('Frozen meltdown',mtInformation,[mbOK],0);
inc(LineCount);inc(Countess);
RichEdit1.Lines.Insert(LineCount, '  ');
{Always have a blank}
inc(CountDracula);inc(LineCount);BlankCount:=LineCount+6;
   WorkingString:= RichEdit1.Lines[LineKeeper];
   str(MealCount,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   If (MealCount = 0) then WorkingString:=' ';
   RichEdit1.Lines[LineKeeper]:=WorkingString;
   LineKeeper:=LineCount;TotalMeals:=(TotalMeals+ MealCount);MealCount:=0;


{Load FFSSD}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFSSD.db';
MOWZDB.DSRTable.Active := True;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);inc(Countess);inc(MealCount);
      WorkingString:= ' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['Route']+'    ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['SorD']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(53- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      DayString:=MOWZDB.DSRTable['Diet Memo'];
      If (Length(DayString) > 21) then begin
      WorkingString:= WorkingString+Copy(DayString,1,21);
      RichEdit1.Lines[LineCount]:=WorkingString;
      inc(LineCount);inc(Countess);
      WorkingString:= ('    '+Copy(DayString,22,70) );
      end else WorkingString:= WorkingString+ DayString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{MUST KNOW how many lines there should be as MAX
then delete the extra Client lines as they are not used}
Lounger:= (BlankCount-LineCount);LineCount:=(LineCount+Lounger );
For I:=1 to Lounger do begin
      RichEdit1.Lines.Delete((LineCount));
      dec(LineCount);
      end;
If ( (Countess + CountDracula) <> LineCount) then
 MessageDlg('Frozen meltdown',mtInformation,[mbOK],0);
inc(LineCount);inc(Countess);
RichEdit1.Lines.Insert(LineCount, '  ');
{Always have a blank}
inc(CountDracula);inc(LineCount);BlankCount:=LineCount+6;
   WorkingString:= RichEdit1.Lines[LineKeeper];
   str(MealCount,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   If (MealCount = 0) then WorkingString:=' ';
   RichEdit1.Lines[LineKeeper]:=WorkingString;
   LineKeeper:=LineCount;TotalMeals:=(TotalMeals+ MealCount);MealCount:=0;


{Load FFSSDS}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'FFSSDS.db';
MOWZDB.DSRTable.Active := True;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);inc(Countess);inc(MealCount);
      WorkingString:= ' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['Route']+'    ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['SorD']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(53- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      DayString:=MOWZDB.DSRTable['Diet Memo'];
      If (Length(DayString) > 21) then begin
      WorkingString:= WorkingString+Copy(DayString,1,21);
      RichEdit1.Lines[LineCount]:=WorkingString;
      inc(LineCount);inc(Countess);
      WorkingString:= ('    '+Copy(DayString,22,70) );
      end else WorkingString:= WorkingString+ DayString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{MUST KNOW how many lines there should be as MAX
then delete the extra Client lines as they are not used}
Lounger:= (BlankCount-LineCount);LineCount:=(LineCount+Lounger );
For I:=1 to Lounger do begin
      RichEdit1.Lines.Delete((LineCount));
      dec(LineCount);
      end;
If ( (Countess + CountDracula) <> LineCount) then
 MessageDlg('Frozen meltdown',mtInformation,[mbOK],0);
inc(LineCount);{inc(Countess);}
RichEdit1.Lines.Insert(LineCount, '  ');
{Always have a blank}
{inc(CountDracula,3);}inc(LineCount);
   WorkingString:= RichEdit1.Lines[LineKeeper];
   str(MealCount,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   If (MealCount = 0) then WorkingString:=' ';
   RichEdit1.Lines[LineKeeper]:=WorkingString;
   TotalMeals:=(TotalMeals+ MealCount);
   {   LineKeeper:=LineCount;MealCount:=0;  }
   WorkingString:= RichEdit1.Lines[LineCount];
   str(TotalMeals,DayString);
   WorkingString:= (WorkingString+' '+DayString);
   RichEdit1.Lines[LineCount]:=WorkingString;
(*  Hospital does not like it

inc(LineCount,2);

{FROZEN FOOD 2 lines for Sat and Sun}
{Frozen Text Sat}
      MOWZDB.DSRTable.Active := False;
      MOWZDB.DSRTable.TableName := 'FFSAT.db';
      MOWZDB.DSRTable.Active := True;
{    WorkingString:= RichEdit1.Lines[LineCount];}
      str(MOWZDB.DSRTable['Total#']:3:0,PDString);
      WorkingString:= '      Saturday Total: '+PDString+';  ';
      str(MOWZDB.DSRTable['Regular#']:3:0,PDString);
      WorkingString:= WorkingString+' Regular '+PDString+',  ';
      str(MOWZDB.DSRTable['Low Salt#']:3:0,PDString);
      WorkingString:= WorkingString+' Low Salt '+PDString+',  ';
      str(MOWZDB.DSRTable['Diabetic#']:3:0,PDString);
      WorkingString:= WorkingString+' Diabetic '+PDString+',  ';
      str(MOWZDB.DSRTable['DBLS#']:3:0,PDString);
      WorkingString:= WorkingString+'DBLS '+PDString+',  ';
      str(MOWZDB.DSRTable['Wheat#']:3:0,PDString);
      WorkingString:= WorkingString+' Wheat '+PDString+',  ';
      str(MOWZDB.DSRTable['Ensure#']:3:0,PDString);
      WorkingString:= WorkingString+' Ensure '+PDString;
      RichEdit1.Lines[LineCount]:= WorkingString;
{Frozen Text Sun}
      inc(LineCount);
      MOWZDB.DSRTable.Active := False;
      MOWZDB.DSRTable.TableName := 'FFSUN.db';
      MOWZDB.DSRTable.Active := True;
{    WorkingString:= RichEdit1.Lines[LineCount];}
      str(MOWZDB.DSRTable['Total#']:3:0,PDString);
      WorkingString:= '      Sunday   Total: '+PDString+';  ';
      str(MOWZDB.DSRTable['Regular#']:3:0,PDString);
      WorkingString:= WorkingString+' Regular '+PDString+',  ';
      str(MOWZDB.DSRTable['Low Salt#']:3:0,PDString);
      WorkingString:= WorkingString+' Low Salt '+PDString+',  ';
      str(MOWZDB.DSRTable['Diabetic#']:3:0,PDString);
      WorkingString:= WorkingString+' Diabetic '+PDString+',  ';
      str(MOWZDB.DSRTable['DBLS#']:3:0,PDString);
      WorkingString:= WorkingString+'DBLS '+PDString+',  ';
      str(MOWZDB.DSRTable['Wheat#']:3:0,PDString);
      WorkingString:= WorkingString+' Wheat '+PDString+',  ';
      str(MOWZDB.DSRTable['Ensure#']:3:0,PDString);
      WorkingString:= WorkingString+' Ensure '+PDString;
      RichEdit1.Lines[LineCount]:= WorkingString;
*)
{Reset}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR1.db';
end;
(************************************************************)
(************************************************************)

(************************************************************)
(************************************************************)

(************************************************************)
(************************************************************)
procedure TEditRich.DoDailySummary(IsDaily:Boolean);
var
PDString,DayString,WorkingString:String;
LineCount,Longer,I,DayNameI:Integer;
begin
    DayNameI := DayOfWeek(Date);
    DayString:= FormatDateTime('dmmmyy', Date);
If IsDaily then begin             {MOWDS_Base.RTF}
    RichEdit1.Lines.LoadFromFile('MOW01DS_Base.RTF');
    SetFileName('MOW01DS_'+DayString+'.RTF');
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
    WorkingString:= '    MOW01DS_'+DayString+'.RTF';
    DayString:= FormatDateTime('d  mmm, yyyy', Date);
    RichEdit1.Lines[1]:=
    WorkingString+'                                        '+DayString;
end else begin
    RichEdit1.Lines.LoadFromFile('MOW16MS_Base.RTF');
    SetFileName('MOW16MS_'+DayString+'.RTF');
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
    WorkingString:= '    MOW16MS_'+DayString+'.RTF';
    DayString:= FormatDateTime('d  mmm, yyyy', Date);
    RichEdit1.Lines[1]:=
    WorkingString+'                                        '+DayString;
end;
{Load DSR 1}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR1.db';
MOWZDB.DSRTable.Active := True;
LineCount:=5;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(32- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['PD']:3:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 17) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DSR 4}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR4.db';
MOWZDB.DSRTable.Active := True;
LineCount:=5;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME']+' ';
      Longer:=(59- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(68- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['PD']:2:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;


{Load DSR 2  19}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR2.db';
MOWZDB.DSRTable.Active := True;
LineCount:=18;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(32- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['PD']:3:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 29) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DSR 5}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR5.db';
MOWZDB.DSRTable.Active := True;
LineCount:=18;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME']+' ';
      Longer:=(59- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(68- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['PD']:2:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load DSR 3}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR3.db';
MOWZDB.DSRTable.Active := True;
LineCount:=31;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(32- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['PD']:3:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 42) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DSR 6}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR6.db';
MOWZDB.DSRTable.Active := True;
LineCount:=31;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME']+' ';
      Longer:=(59- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(68- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['PD']:2:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load DSR 7}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR7.db';
MOWZDB.DSRTable.Active := True;
LineCount:=44;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME']+' ';
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['DIET']+' ';
      Longer:=(32- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['PD']:3:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 53) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='   ';
end;

{Load DSRS}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSRS.db';
MOWZDB.DSRTable.Active := True;
LineCount:=44;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(41- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['A']+' ';
      Longer:=(55- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['N1']:3:0,PDString);
      WorkingString:= WorkingString+PDString+'  ';
{Longer?}
      WorkingString:= WorkingString+MOWZDB.DSRTable['B']+' ';
      Longer:=(69- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['N2']:3:0,PDString);
      WorkingString:= WorkingString+PDString+'  ';

      WorkingString:= WorkingString+MOWZDB.DSRTable['C']+' ';
      Longer:=(84- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['N3']:3:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{on Fridays get Frozen food}
If (DayNameI = 6) then begin
{Frozen Text Sat}
   MOWZDB.DSRTable.Active := False;
   MOWZDB.DSRTable.TableName := 'FFSAT.db';
   MOWZDB.DSRTable.Active := True;
    WorkingString:= RichEdit1.Lines[55];
      str(MOWZDB.DSRTable['Total#']:3:0,PDString);
      WorkingString:= WorkingString+'      Saturday Total: '+PDString+';  ';
      str(MOWZDB.DSRTable['Regular#']:3:0,PDString);
      WorkingString:= WorkingString+' Regular '+PDString+',  ';
      str(MOWZDB.DSRTable['Low Salt#']:3:0,PDString);
      WorkingString:= WorkingString+' Low Salt '+PDString+',  ';
      str(MOWZDB.DSRTable['Diabetic#']:3:0,PDString);
      WorkingString:= WorkingString+' Diabetic '+PDString+',  ';
      str(MOWZDB.DSRTable['DBLS#']:3:0,PDString);
      WorkingString:= WorkingString+'DBLS '+PDString+',  ';
      str(MOWZDB.DSRTable['Wheat#']:3:0,PDString);
      WorkingString:= WorkingString+' Wheat '+PDString+',  ';
      str(MOWZDB.DSRTable['Ensure#']:3:0,PDString);
      WorkingString:= WorkingString+' Ensure '+PDString;
    RichEdit1.Lines[55]:= WorkingString;
{Frozen Text Sun}
    MOWZDB.DSRTable.Active := False;
    MOWZDB.DSRTable.TableName := 'FFSUN.db';
    MOWZDB.DSRTable.Active := True;
    WorkingString:= RichEdit1.Lines[56];
      str(MOWZDB.DSRTable['Total#']:3:0,PDString);
      WorkingString:= WorkingString+'      Sunday   Total: '+PDString+';  ';
      str(MOWZDB.DSRTable['Regular#']:3:0,PDString);
      WorkingString:= WorkingString+' Regular '+PDString+',  ';
      str(MOWZDB.DSRTable['Low Salt#']:3:0,PDString);
      WorkingString:= WorkingString+' Low Salt '+PDString+',  ';
      str(MOWZDB.DSRTable['Diabetic#']:3:0,PDString);
      WorkingString:= WorkingString+' Diabetic '+PDString+',  ';
      str(MOWZDB.DSRTable['DBLS#']:3:0,PDString);
      WorkingString:= WorkingString+'DBLS '+PDString+',  ';
      str(MOWZDB.DSRTable['Wheat#']:3:0,PDString);
      WorkingString:= WorkingString+' Wheat '+PDString+',  ';
      str(MOWZDB.DSRTable['Ensure#']:3:0,PDString);
      WorkingString:= WorkingString+' Ensure '+PDString;
    RichEdit1.Lines[56]:= WorkingString;
end;
{Reset}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR1.db';
end;
(************************************************************)
(************************************************************)



(************************************************************)
(************************************************************)
procedure  TEditRich.DoDepositSummary;
var
DayString,WorkingString:String;
LineCount,Longer,I:Integer;
begin
    RichEdit1.Lines.LoadFromFile('MOW37DS_Base.RTF');
    DayString:= FormatDateTime('dmmmyy', Date);
    SetFileName('MOW37DS_'+DayString+'.RTF');
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
{    WorkingString:= RichEdit1.Lines[1];}
    WorkingString:= '      MOW37DS_'+DayString+'.RTF';
    DayString:= FormatDateTime('d  mmm, yyyy', Date);
    RichEdit1.Lines[1]:=
    WorkingString+'                                        '+DayString;

{Load DSR 1}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSS1.db';
MOWZDB.DSRTable.Active := True;
LineCount:=5;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 17) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DSR 4}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSS4.db';
MOWZDB.DSRTable.Active := True;
LineCount:=5;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;


{Load DSR 2  19}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSS2.db';
MOWZDB.DSRTable.Active := True;
LineCount:=18;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 29) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DSR 5}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSS5.db';
MOWZDB.DSRTable.Active := True;
LineCount:=18;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load DSR 3}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSS3.db';
MOWZDB.DSRTable.Active := True;
LineCount:=31;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 42) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DSR 6}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSS6.db';
MOWZDB.DSRTable.Active := True;
LineCount:=31;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load DSR 7}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSS7.db';
MOWZDB.DSRTable.Active := True;
LineCount:=44;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 46) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='   ';
end;


{Reset}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR1.db';
end;
(************************************************************)
(************************************************************)






(************************************************************)
(************************************************************)
procedure  TEditRich.DoDepositDueSummary(IsWeekly:Boolean);
var
FDSName,PDString,DayString,WorkingString:String;
LineCount,Longer,I:Integer;
begin         {MOWFDS_Base  MOW35WD_Base  MOW36MD_Base}

IF IsWeekly then begin
    RichEdit1.Lines.LoadFromFile('MOW35WD_Base.RTF');
    DayString:= FormatDateTime('dmmmyy', Date);
    SetFileName('MOW35WD_'+DayString+'.RTF');
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
    WorkingString:= '      MOW35WD_'+DayString+'.RTF';
    DayString:= FormatDateTime('d  mmm, yyyy', Date);
    RichEdit1.Lines[1]:=
    WorkingString+'                                       '+DayString;

   FDSName:= 'DST';
   WorkingString:=RichEdit1.Lines[3];
   PDString:='WEEKLY DEPOSIT SUMMARY';
   WorkingString:= WorkingString+PDString;
   RichEdit1.Lines[3]:=WorkingString;
end else begin {Monthly}
    RichEdit1.Lines.LoadFromFile('MOW36MD_Base.RTF');
    DayString:= FormatDateTime('dmmmyy', Date);
    SetFileName('MOW36MD_'+DayString+'.RTF');
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
    WorkingString:= '      MOW36MD_'+DayString+'.RTF';
    DayString:= FormatDateTime('d  mmm, yyyy', Date);
    RichEdit1.Lines[1]:=
    WorkingString+'                                      '+DayString;

FDSName:= 'DSTM';
   WorkingString:=RichEdit1.Lines[3];
   PDString:='MONTHLY DEPOSIT SUMMARY';
   WorkingString:= WorkingString+PDString;
   RichEdit1.Lines[3]:=WorkingString;
end;

{Load DST 1}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := FDSName+'1.db';
MOWZDB.DSRTable.Active := True;
LineCount:=5;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Amount Due']:6:2,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 17) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DST 4}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := FDSName+'4.db';
MOWZDB.DSRTable.Active := True;
LineCount:=5;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(59- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Amount Due']:6:2,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;


{Load DST 2  19}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := FDSName+'2.db';
MOWZDB.DSRTable.Active := True;
LineCount:=18;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Amount Due']:6:2,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 29) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DST 5}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := FDSName+'5.db';
MOWZDB.DSRTable.Active := True;
LineCount:=18;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(59- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Amount Due']:6:2,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load DST 3}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := FDSName+'3.db';
MOWZDB.DSRTable.Active := True;
LineCount:=31;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Amount Due']:6:2,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 42) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='  ';
end;

{Load DST 6}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := FDSName+'6.db';
MOWZDB.DSRTable.Active := True;
LineCount:=31;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(43- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(59- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Amount Due']:6:2,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load DST 7}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := FDSName+'7.db';
MOWZDB.DSRTable.Active := True;
LineCount:=44;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= '      ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['I']+' ';
      WorkingString:= WorkingString+MOWZDB.DSRTable['LNAME'];
      Longer:=(23- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Amount Due']:6:2,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
While (LineCount < 46) do begin
      inc(LineCount);
      RichEdit1.Lines[LineCount]:='   ';
end;

{Reset}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR1.db';
end;
(************************************************************)
(************************************************************)


(************************************************************)
(************************************************************)
procedure  TEditRich.DoMealCount;
var
PDString,DayString,WorkingString:String;
LineCount,Longer,I:Integer;
begin
    RichEdit1.Lines.LoadFromFile('MOW14MC_Base.RTF');
    DayString:= FormatDateTime('dmmmyy', Date);
    SetFileName('MOW14MC_'+DayString+'.RTF');
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
{    WorkingString:= RichEdit1.Lines[1];}
    WorkingString:= '      MOW14MC_'+DayString+'.RTF';
    DayString:= FormatDateTime('d  mmm, yyyy', Date);
    RichEdit1.Lines[1]:=
    WorkingString+'                                       '
    +DayString;

{Load HOSPITAL_TEMP}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'HOSPITAL_TEMP.db';
MOWZDB.DSRTable.Active := True;
LineCount:=10;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      str(MOWZDB.DSRTable['Day']:2:0,PDString);
      WorkingString:= WorkingString+PDString;
      Longer:=(10- Length(PDString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Meals']:3:0,PDString);
      WorkingString:= WorkingString+PDString;
      Longer:=(10- Length(PDString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      str(MOWZDB.DSRTable['Total']:4:0,PDString);
      WorkingString:= WorkingString+PDString;
      RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Reset}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR1.db';
end;
(************************************************************)
(************************************************************)

(************************************************************)
(************************************************************)
procedure TEditRich.DoMOWDates;
var
DayString,WorkingString:String;
LineCount,Longer,I:Integer;
begin
    RichEdit1.Lines.LoadFromFile('MOW18DS_Base.RTF');
    RichEdit1.Lines[0]:=' ';
    DayString:= FormatDateTime('dmmmyy', Date);
    SetFileName('MOW18DS_'+DayString+'.RTF');
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
    WorkingString:= '          MOW18DS_'+DayString+'.RTF';
    DayString:= FormatDateTime('d  mmm, yyyy', Date);
    RichEdit1.Lines[55]:=
    WorkingString+',  '+DayString;

{Load MDSP}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDSP.db';
MOWZDB.DSRTable.Active := True;
LineCount:=6;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 12 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load MDAG}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDAG.db';
MOWZDB.DSRTable.Active := True;
LineCount:=6;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(36- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 12 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;


{Load MDFB}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDFB.db';
MOWZDB.DSRTable.Active := True;
LineCount:=13;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 19 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load MDMH}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDMH.db';
MOWZDB.DSRTable.Active := True;
LineCount:=13;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(36- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 19 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load MDSL}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDSL.db';
MOWZDB.DSRTable.Active := True;
LineCount:=20;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 26 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load MDSJ}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDSJ.db';
MOWZDB.DSRTable.Active := True;
LineCount:=20;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(36- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 26 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;


{Load MDFC}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDFC.db';
MOWZDB.DSRTable.Active := True;
LineCount:=27;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 33 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load MDHC}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDHC.db';
MOWZDB.DSRTable.Active := True;
LineCount:=27;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(36- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 33 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;


{Load MDSF}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDSF.db';
MOWZDB.DSRTable.Active := True;
LineCount:=34;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 40 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load MDPR}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDPR.db';
MOWZDB.DSRTable.Active := True;
LineCount:=34;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(36- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 40 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;
{Load MDUM}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDUM.db';
MOWZDB.DSRTable.Active := True;
LineCount:=41;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 47 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Load MDGS}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDGS.db';
MOWZDB.DSRTable.Active := True;
LineCount:=41;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      Longer:=(36- Length(WorkingString));
      For I:= 0 to Longer do begin WorkingString:= (WorkingString+' ');end;
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 47 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;


{Load MDUP}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'MDUP.db';
MOWZDB.DSRTable.Active := True;
LineCount:=48;
MOWZDB.DSRTable.First;
while not MOWZDB.DSRTable.EOF do begin
      inc(LineCount);
      WorkingString:= RichEdit1.Lines[LineCount];
      WorkingString:= WorkingString+MOWZDB.DSRTable['Datestring']+' ';
      If LineCount< 54 then RichEdit1.Lines[LineCount]:=WorkingString;
      MOWZDB.DSRTable.Next;
end;

{Reset}
MOWZDB.DSRTable.Active := False;
MOWZDB.DSRTable.TableName := 'DSR1.db';
end;
(************************************************************)
(************************************************************)



procedure TEditRich.Label1mMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
end;

procedure TEditRich.RulerClick(Sender: TObject);
begin
{Check for Tabs and add one HERE}
end;

procedure TEditRich.FontColorClick(Sender: TObject);
begin
ColorGrid1.Visible:=True;
end;

procedure TEditRich.ColorGrid1Click(Sender: TObject);
begin
Case ColorGrid1.Selection of
0: RichEdit1.SelAttributes.Color:=clBlack;{Black}
1:RichEdit1.SelAttributes.Color:=clMaroon;{Maroon}
2:RichEdit1.SelAttributes.Color:=clGreen;{Green}
3:RichEdit1.SelAttributes.Color:=clOlive;{[Olive green}
4:RichEdit1.SelAttributes.Color:=clNavy;{Navy blue}
5:RichEdit1.SelAttributes.Color:=clPurple;{Purple}
6:RichEdit1.SelAttributes.Color:=clTeal;{Teal}
7:RichEdit1.SelAttributes.Color:=clGray;{Gray}
8:RichEdit1.SelAttributes.Color:=clSilver;{Silver}
9:RichEdit1.SelAttributes.Color:=clRed;{Red}
10:RichEdit1.SelAttributes.Color:=clLime;{Lime green}
11:RichEdit1.SelAttributes.Color:=clYellow;{Yellow}
12:RichEdit1.SelAttributes.Color:=clBlue;{Blue}
13:RichEdit1.SelAttributes.Color:=clFuchsia;{Fuchsia}
14:RichEdit1.SelAttributes.Color:=clAqua;{Aqua}
15:RichEdit1.SelAttributes.Color:=clWhite;{White}
end;
ColorGrid1.Visible:=False;
end;

procedure TEditRich.OleContainer1ObjectMove(OleContainer: TOleContainer;
  const Bounds: TRect);
begin
OleContainer1.BoundsRect := Bounds;
end;



end.
